## asterisk-certified 16.8

=== Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Top level Makefile
#
# Copyright (C) 1999-2010, Digium, Inc.
#
# Mark Spencer <markster@digium.com>
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

# All Makefiles use the following variables:
#
# ASTCFLAGS - compiler options provided by the user (if any)
# _ASTCFLAGS - compiler options provided by the build system
# ASTLDFLAGS - linker flags (not libraries) provided by the user (if any)
# _ASTLDFLAGS - linker flags (not libraries) provided by the build system
# LIBS - additional libraries, at top-level for all links,
#      on a single object just for that object
# SOLINK - linker flags used only for creating dynamically loadable modules
#          as .so files
# DYLINK - linker flags used only for creating shared libaries
#          (.so files on Unix-type platforms, .dylib on Darwin)
#
# Values for ASTCFLAGS and ASTLDFLAGS can be specified in the
# environment when running make, as follows:
#
#	$ ASTCFLAGS="-Werror" make ...
#
# or as a variable value on the make command line itself:
#
#	$ make ASTCFLAGS="-Werror" ...

export ASTTOPDIR		# Top level dir, used in subdirs' Makefiles
export ASTERISKVERSION
export ASTERISKVERSIONNUM

#--- values used for default paths

# DESTDIR is the staging (or final) directory where files are copied
# during the install process. Define it before 'export', otherwise
# export will set it to the empty string making ?= fail.
# Trying to run asterisk from the DESTDIR is completely unsupported
# behavior.
# WARNING: do not put spaces or comments after the value.
DESTDIR?=$(INSTALL_PATH)
export DESTDIR

export INSTALL_PATH       # Additional prefix for the following paths
export ASTETCDIR          # Path for config files
export ASTVARRUNDIR
export ASTSPOOLDIR
export ASTVARLIBDIR
export ASTDATADIR
export ASTDBDIR
export ASTLOGDIR
export ASTLIBDIR
export ASTMODDIR
export ASTMANDIR
export ASTHEADERDIR
export ASTSBINDIR
export AGI_DIR
export ASTCONFPATH
export ASTKEYDIR

export OSARCH             # Operating system

export NOISY_BUILD        # Used in Makefile.rules
export MENUSELECT_CFLAGS  # Options selected in menuselect.
export AST_DEVMODE        # Set to "yes" for additional compiler
                          # and runtime checks
export AST_DEVMODE_STRICT # Enables shadow warnings (-Wshadow)

export _SOLINK            # linker flags for all shared objects
export SOLINK             # linker flags for loadable modules
export DYLINK             # linker flags for shared libraries

#--- paths to various commands
# The makeopts include below tries to set these if they're found during
# configure.
export CC
export CXX
export AR
export RANLIB
export HOST_CC
export BUILD_CC
export INSTALL
export STRIP
export DOWNLOAD
export AWK
export GREP
export MD5
export WGET_EXTRA_ARGS
export LDCONFIG
export LDCONFIG_FLAGS
export PYTHON
export TAR
export PATCH
export SED
export NM

# makeopts is required unless the goal is just {dist{-}}clean
ifeq ($(MAKECMDGOALS),clean)
else ifeq ($(MAKECMDGOALS),distclean)
else ifeq ($(MAKECMDGOALS),dist-clean)
else
include makeopts
endif

# start the primary CFLAGS and LDFLAGS with any that were provided
# to the configure script
_ASTCFLAGS:=$(CONFIG_CFLAGS) $(CONFIG_SIGNED_CHAR)
_ASTLDFLAGS:=$(CONFIG_LDFLAGS)

# Some build systems, such as the one in openwrt, like to pass custom target
# CFLAGS and LDFLAGS in the COPTS and LDOPTS variables; these should also
# go before any build-system computed flags, since they are defaults, not
# overrides
_ASTCFLAGS+=$(COPTS)
_ASTLDFLAGS+=$(LDOPTS)

# libxml2 cflags
_ASTCFLAGS+=$(LIBXML2_INCLUDE)

# BIND_8_COMPAT
_ASTCFLAGS+=$(BIND8_CFLAGS)

#Uncomment this to see all build commands instead of 'quiet' output
#NOISY_BUILD=yes

empty:=
space:=$(empty) $(empty)
ASTTOPDIR:=$(subst $(space),\$(space),$(CURDIR))

# Overwite config files on "make samples" or other config installation targets
OVERWRITE=y

# Include debug and macro symbols in the executables (-g) and profiling info (-pg)
DEBUG=-g3

# Asterisk.conf is located in ASTETCDIR or by using the -C flag
# when starting Asterisk
ASTCONFPATH=$(ASTETCDIR)/asterisk.conf
AGI_DIR=$(ASTDATADIR)/agi-bin

# If you use Apache, you may determine by a grep 'DocumentRoot' of your httpd.conf file
HTTP_DOCSDIR=/var/www/html
# Determine by a grep 'ScriptAlias' of your Apache httpd.conf file
HTTP_CGIDIR=/var/www/cgi-bin

# If your platform's linker expects a prefix on symbols generated from compiling C
# source files, set LINKER_SYMBOL_PREFIX to that value. On some systems, exported symbols
# from C source files are prefixed with '_', for example. If this value is not set
# properly, the linker scripts that live in the '*.exports' files in various places
# in this tree will unintentionally suppress symbols that should be visible
# in the final binary objects.
LINKER_SYMBOL_PREFIX=

# Uncomment this to use the older DSP routines
#_ASTCFLAGS+=-DOLD_DSP_ROUTINES

# Default install directory for DAHDI hooks.
DAHDI_UDEV_HOOK_DIR = /usr/share/dahdi/span_config.d

# If the file .asterisk.makeopts is present in your home directory, you can
# include all of your favorite menuselect options so that every time you download
# a new version of Asterisk, you don't have to run menuselect to set them.
# The file /etc/asterisk.makeopts will also be included but can be overridden
# by the file in your home directory.

ifeq ($(wildcard menuselect.makeopts),)
	USER_MAKEOPTS=$(wildcard ~/.asterisk.makeopts)
	GLOBAL_MAKEOPTS=$(wildcard /etc/asterisk.makeopts)
else
	USER_MAKEOPTS=
	GLOBAL_MAKEOPTS=
endif


MOD_SUBDIR_CFLAGS="-I$(ASTTOPDIR)/include"
OTHER_SUBDIR_CFLAGS="-I$(ASTTOPDIR)/include"

# Create OPTIONS variable, but probably we can assign directly to ASTCFLAGS
OPTIONS=

ifeq ($(findstring -save-temps,$(_ASTCFLAGS) $(ASTCFLAGS)),)
  ifeq ($(findstring -pipe,$(_ASTCFLAGS) $(ASTCFLAGS)),)
    _ASTCFLAGS+=-pipe
  endif
endif

ifeq ($(findstring -Wall,$(_ASTCFLAGS) $(ASTCFLAGS)),)
  _ASTCFLAGS+=-Wall
endif

_ASTCFLAGS+=-Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations $(AST_NESTED_FUNCTIONS) $(AST_CLANG_BLOCKS) $(DEBUG)
ADDL_TARGETS=

ifeq ($(AST_DEVMODE),yes)
  _ASTCFLAGS+=-Werror
  _ASTCFLAGS+=-Wunused
  _ASTCFLAGS+=$(AST_DECLARATION_AFTER_STATEMENT)
  _ASTCFLAGS+=$(AST_TRAMPOLINES)
  _ASTCFLAGS+=-Wundef
  _ASTCFLAGS+=-Wmissing-format-attribute
  _ASTCFLAGS+=-Wformat=2
  ifeq ($(AST_DEVMODE_STRICT),yes)
    _ASTCFLAGS+=-Wshadow
  endif
  ifneq ($(DISABLE_XMLDOC),yes)
    ADDL_TARGETS+=validate-docs
  endif
endif

ifeq ($(OSARCH),NetBSD)
  _ASTCFLAGS+=-isystem /usr/pkg/include
else ifneq ($(findstring BSD,$(OSARCH)),)
  _ASTCFLAGS+=-isystem /usr/local/include
endif

ifeq ($(OSARCH),FreeBSD)
  # -V is understood by BSD Make, not by GNU make.
  BSDVERSION=$(shell make -V OSVERSION -f /usr/share/mk/bsd.port.subdir.mk)
  _ASTCFLAGS+=$(shell if test $(BSDVERSION) -lt 500016 ; then echo "-D_THREAD_SAFE"; fi)
endif

ifeq ($(OSARCH),NetBSD)
  _ASTCFLAGS+=-pthread -D__LIBPTHREAD_SOURCE__ -I/usr/pkg/include
endif

ifeq ($(OSARCH),OpenBSD)
  _ASTCFLAGS+=-pthread -ftrampolines
endif

ifeq ($(OSARCH),SunOS)
  _ASTCFLAGS+=-Wcast-align -DSOLARIS -I../include/solaris-compat -I/opt/ssl/include -I/usr/local/ssl/include -D_XPG4_2 -D__EXTENSIONS__
endif

ifeq ($(GREP),)
else ifeq ($(GREP),:)
else
  ASTERISKVERSION:=$(shell GREP=$(GREP) AWK=$(AWK) GIT=$(GIT) build_tools/make_version .)
endif
ifneq ($(AWK),)
  ifneq ($(wildcard .version),)
    ASTERISKVERSIONNUM:=$(shell $(SED) -e 's/^certified\///' -e 's/-cert/./' .version | $(AWK) -F. '{printf "%01d%02d%02d", $$1, $$2, $$3}')
  endif
endif

ifneq ($(wildcard .svn),)
  ASTERISKVERSIONNUM:=999999
endif

ifneq ($(DISABLE_XMLDOC),yes)
  CORE_XMLDOC=doc/core-en_US.xml
  FULL_XMLDOC=doc/full-en_US.xml
else
  CORE_XMLDOC=
  FULL_XMLDOC=
endif

_ASTCFLAGS+=$(OPTIONS)

MOD_SUBDIRS:=third-party channels pbx apps codecs formats cdr cel bridges funcs tests main res addons $(LOCAL_MOD_SUBDIRS)
OTHER_SUBDIRS:=utils agi contrib
SUBDIRS:=$(OTHER_SUBDIRS) $(MOD_SUBDIRS)
SUBDIRS_INSTALL:=$(SUBDIRS:%=%-install)
SUBDIRS_CLEAN:=$(SUBDIRS:%=%-clean)
SUBDIRS_DIST_CLEAN:=$(SUBDIRS:%=%-dist-clean)
SUBDIRS_UNINSTALL:=$(SUBDIRS:%=%-uninstall)
MOD_SUBDIRS_MENUSELECT_TREE:=$(MOD_SUBDIRS:%=%-menuselect-tree)

ifneq ($(findstring darwin,$(OSARCH)),)
  _ASTCFLAGS+=-D__Darwin__ -mmacosx-version-min=10.6
  _SOLINK=-mmacosx-version-min=10.6 -Wl,-undefined,dynamic_lookup
  _SOLINK+=/usr/lib/bundle1.o
  SOLINK=-bundle $(_SOLINK)
  DYLINK=-Wl,-dylib $(_SOLINK)
  _ASTLDFLAGS+=-L/usr/local/lib
else
# These are used for all but Darwin
  SOLINK=-shared
  DYLINK=$(SOLINK)
  ifeq ($(OSARCH),NetBSD)
    _ASTLDFLAGS+=-L/usr/pkg/lib
  else ifneq ($(findstring BSD,$(OSARCH)),)
    _ASTLDFLAGS+=-L/usr/local/lib
  endif
endif

# Include rpath settings
_ASTLDFLAGS+=$(AST_RPATH)

ifeq ($(OSARCH),SunOS)
  SOLINK=-shared -fpic -L/usr/local/ssl/lib -lrt
  DYLINK=$(SOLINK)
endif

ifeq ($(OSARCH),OpenBSD)
  SOLINK=-shared -fpic
  DYLINK=$(SOLINK)
endif

# comment to print directories during submakes
#PRINT_DIR=yes

ifneq ($(INSIDE_EMACS),)
PRINT_DIR=yes
endif

SILENTMAKE:=$(MAKE) --quiet --no-print-directory
ifneq ($(PRINT_DIR)$(NOISY_BUILD),)
SUBMAKE:=$(MAKE)
else
SUBMAKE:=$(MAKE) --quiet --no-print-directory
endif

# $(MAKE) is printed in several places, and we want it to be a
# fixed size string. Define a variable whose name has also the
# same size, so we can easily align text.
ifeq ($(MAKE), gmake)
	mK="gmake"
else
	mK=" make"
endif

all: _all
	@echo " +--------- Asterisk Build Complete ---------+"
	@echo " + Asterisk has successfully been built, and +"
	@echo " + can be installed by running:              +"
	@echo " +                                           +"
	@echo " +               $(mK) install               +"
	@echo " +-------------------------------------------+"

full: _full
	@echo " +--------- Asterisk Build Complete ---------+"
	@echo " + Asterisk has successfully been built, and +"
	@echo " + can be installed by running:              +"
	@echo " +                                           +"
	@echo " +               $(mK) install               +"
	@echo " +-------------------------------------------+"


_all: makeopts $(SUBDIRS) $(CORE_XMLDOC) $(ADDL_TARGETS)

_full: makeopts $(SUBDIRS) $(FULL_XMLDOC) $(ADDL_TARGETS)

makeopts: configure
	@echo "****"
	@echo "**** The configure script must be executed before running '$(MAKE)'."
	@echo "****               Please run \"./configure\"."
	@echo "****"
	@exit 1

menuselect.makeopts: menuselect/menuselect menuselect-tree makeopts build_tools/menuselect-deps $(GLOBAL_MAKEOPTS) $(USER_MAKEOPTS)
ifeq ($(filter %.menuselect,$(MAKECMDGOALS)),)
	menuselect/menuselect --check-deps $@
	menuselect/menuselect --check-deps $@ $(GLOBAL_MAKEOPTS) $(USER_MAKEOPTS)
endif

$(MOD_SUBDIRS_MENUSELECT_TREE):
	+@$(SUBMAKE) -C $(@:-menuselect-tree=) SUBDIR=$(@:-menuselect-tree=) moduleinfo
	+@$(SUBMAKE) -C $(@:-menuselect-tree=) SUBDIR=$(@:-menuselect-tree=) makeopts

$(SUBDIRS): makeopts .lastclean main/version.c include/asterisk/build.h include/asterisk/buildopts.h defaults.h

ifeq ($(findstring $(OSARCH), mingw32 cygwin ),)
main: third-party
else
    # Windows: we need to build main (i.e. the asterisk dll) first,
    # followed by res, followed by the other directories, because
    # dll symbols must be resolved during linking and not at runtime.
D1:= $(filter-out main,$(MOD_SUBDIRS))
D1:= $(filter-out res,$(D1))

$(D1): res
res:	main
endif

$(MOD_SUBDIRS): makeopts
	+@_ASTCFLAGS="$(MOD_SUBDIR_CFLAGS) $(_ASTCFLAGS)" ASTCFLAGS="$(ASTCFLAGS)" _ASTLDFLAGS="$(_ASTLDFLAGS)" ASTLDFLAGS="$(ASTLDFLAGS)" $(SUBMAKE) --no-builtin-rules -C $@ SUBDIR=$@ all

$(OTHER_SUBDIRS): makeopts
	+@_ASTCFLAGS="$(OTHER_SUBDIR_CFLAGS) $(_ASTCFLAGS)" ASTCFLAGS="$(ASTCFLAGS)" _ASTLDFLAGS="$(_ASTLDFLAGS)" ASTLDFLAGS="$(ASTLDFLAGS)" $(SUBMAKE) --no-builtin-rules -C $@ SUBDIR=$@ all

defaults.h: makeopts .lastclean build_tools/make_defaults_h

=== third-party/pjproject/Makefile ===
.PHONY: _all all _install install clean distclean echo_cflags configure

.NOTPARALLEL:

include ../versions.mak
export PJDIR := $(shell pwd -P)/source

SPECIAL_TARGETS :=

ifneq ($(findstring configure,$(MAKECMDGOALS))$(findstring echo_cflags,$(MAKECMDGOALS)),)
# Run from $(ASTTOPDIR)/configure
    SPECIAL_TARGETS += configure
endif

ifeq ($(findstring echo_cflags,$(MAKECMDGOALS)),echo_cflags)
    -include build.mak
    ECHO_PREFIX=@\#
endif

ifeq ($(findstring clean,$(MAKECMDGOALS)),clean)
# clean or distclean
    SPECIAL_TARGETS += clean
endif

ifeq ($(findstring uninstall,$(MAKECMDGOALS)),uninstall)
    SPECIAL_TARGETS += uninstall
endif


ifneq ($(wildcard ../../makeopts),)
    include ../../makeopts
endif

TARGETS = build.mak

ifeq ($(SPECIAL_TARGETS),)
# Run locally or from $(ASTTOPDIR)/Makefile.  All include files should be present
    ifeq ($(wildcard ../../makeopts),)
        $(error ASTTOPDIR/configure hasn't been run)
    endif

    ifeq ($(PJPROJECT_BUNDLED),yes)
        ifneq ($(wildcard ../../menuselect.makeopts),)
            include ../../menuselect.makeopts
        else
            $(warning ASTTOPDIR/menuselect hasn't been run yet.  Can't find debug options.)
        endif
		include ../../Makefile.rules
		include ../Makefile.rules
		include Makefile.rules

        all: _all
        install: _install

        include source/user.mak
        include source/version.mak
        include source/build.mak
        CF := $(filter-out -W%,$(CC_CFLAGS))
        CF := $(filter-out -I%,$(CF))
        ifeq ($(AST_DEVMODE),yes)
            apps := source/pjsip-apps/bin/pjsua-$(TARGET_NAME) source/pjsip-apps/bin/pjsystest-$(TARGET_NAME)
            TARGETS += $(apps)
            ifneq ($(PYTHONDEV_LIB),)
                TARGETS += source/pjsip-apps/src/python/_pjsua.so
            endif
            CF += -DPJPROJECT_BUNDLED_ASSERTIONS=yes
        endif
        MALLOC_DEBUG_LIBS = source/pjsip-apps/lib/libasterisk_malloc_debug.a
        MALLOC_DEBUG_LDFLAGS = -L$(PJDIR)/pjsip-apps/lib -Wl,-whole-archive -lasterisk_malloc_debug -Wl,-no-whole-archive
        TARGETS += pjproject.symbols
    else
        all install:
    endif
else
	include ../../Makefile.rules
	include ../Makefile.rules
	include Makefile.rules
endif

export PJ_CFLAGS := $(filter-out -O% -g%,$(PJ_CFLAGS))
export CFLAGS += $(CF) $(OPENSSL_INCLUDE)
export LDFLAGS += $(CC_LDFLAGS) $(OPENSSL_LIB)

ECHO_PREFIX := $(ECHO_PREFIX) echo '[pjproject] '
SHELL_ECHO_PREFIX := echo '[pjproject] '

_all: $(TARGETS)

.DELETE_ON_ERROR:

$(DOWNLOAD_DIR)/$(TARBALL_FILE): ../versions.mak
	$(CMD_PREFIX) ($(TARBALL_EXISTS) && $(TARBALL_VERIFY) && touch $@) || (rm -rf $@ ;\
	$(TARBALL_DOWNLOAD)) || (rm -rf $@ ;\
	$(SHELL_ECHO_PREFIX) Retrying download ; $(TARBALL_DOWNLOAD))

source/.unpacked: $(DOWNLOAD_DIR)/$(TARBALL_FILE)
	$(CMD_PREFIX) $(TARBALL_VERIFY) || (rm -rf $@ ;\
	$(SHELL_ECHO_PREFIX) Retrying download ; $(TARBALL_DOWNLOAD))
	$(ECHO_PREFIX) Unpacking $<
	-@rm -rf source pjproject-*/ >/dev/null 2>&1
	$(CMD_PREFIX) $(TAR) -xjf $<
	@mv pjproject-$(PJPROJECT_VERSION) source
	$(ECHO_PREFIX) Applying patches "$(realpath patches)" "$(realpath .)/source"
	$(CMD_PREFIX) ../apply_patches $(QUIET_CONFIGURE) "$(realpath patches)" "$(realpath .)/source"
	-@touch source/.unpacked

source/version.mak: source/.unpacked

source/user.mak: source/.unpacked patches/user.mak
	$(ECHO_PREFIX) Applying user.mak
	$(CMD_PREFIX) cp -f patches/user.mak source/

source/pjlib/include/pj/%.h: patches/%.h
	$(ECHO_PREFIX) Applying custom include file $<
	$(CMD_PREFIX) cp -f $< source/pjlib/include/pj/

.rebuild_needed: $(wildcard ../../.lastclean)
	$(ECHO_PREFIX) Rebuilding
	$(CMD_PREFIX) $(MAKE) clean $(REALLY_QUIET)

source/build.mak: Makefile.rules source/version.mak source/user.mak $(addprefix source/pjlib/include/pj/,$(notdir $(wildcard patches/*.h))) .rebuild_needed
	$(ECHO_PREFIX) Configuring with $(PJPROJECT_CONFIG_OPTS) 
	$(CMD_PREFIX) (cd source ; ./aconfigure $(QUIET_CONFIGURE) $(PJPROJECT_CONFIG_OPTS))

build.mak: source/build.mak
	$(CMD_PREFIX) $(GREP) -v -e prefix -e "export PJ_SHARED_LIBRARIES" -e MACHINE_NAME \
		-e OS_NAME -e HOST_NAME -e CC_NAME -e CROSS_COMPILE -e LINUX_POLL $< > $@

configure: source/build.mak

# We need to filter-out any -O and -g options in PJ_CFLAGS before echoing out
# the result so Asterisk modules don't have the optimization and symbolic debug
# options overridden by the PJPROJECT configure script selected settings.
echo_cflags: source/build.mak
	@echo $(filter-out -O% -g%,$(PJ_CFLAGS))

libpj%.a: source/build.mak
	$(ECHO_PREFIX) Compiling lib $(@F)
	$(CMD_PREFIX) $(MAKE) -C $(dir $(shell dirname $@))/build $(@F) $(REALLY_QUIET)

# pjsua needs resample and g711 to successfully run the testsuite
libresample%.a: source/build.mak
	$(ECHO_PREFIX) Compiling lib $(@F)
	$(CMD_PREFIX) $(MAKE) -C $(dir $(shell dirname $@))/build/resample all $(REALLY_QUIET)

# We need to compile pjlib, then pjlib-util, then the rest
# so we separate them out and create the dependencies
PJLIB_LIB_FILES = $(foreach lib,$(PJ_LIB_FILES),$(if $(findstring libpj-,$(lib)),$(lib),))
PJLIB_UTIL_LIB_FILES = $(foreach lib,$(PJ_LIB_FILES),$(if $(findstring libpjlib-util,$(lib)),$(lib),))
PJSIP_LIB_FILES = $(filter-out $(PJLIB_LIB_FILES) $(PJLIB_UTIL_LIB_FILES) $(APP_THIRD_PARTY_LIB_FILES),$(PJ_LIB_FILES))
ALL_LIB_FILES = $(PJLIB_LIB_FILES) $(PJLIB_UTIL_LIB_FILES) $(PJSIP_LIB_FILES)

$(PJLIB_UTIL_LIB_FILES): $(PJLIB_LIB_FILES)
$(PJSIP_LIB_FILES): $(PJLIB_UTIL_LIB_FILES)

pjproject.symbols: $(ALL_LIB_FILES)
	$(ECHO_PREFIX) Generating symbols
	$(CMD_PREFIX) $(NM) -Pog $(ALL_LIB_FILES) | $(SED) -n -r -e "s/.+: ([pP][jJ][^ ]+) .+/\1/gp" | sort -u > pjproject.symbols

source/pjsip-apps/src/asterisk_malloc_debug.c: patches/asterisk_malloc_debug.c
	$(ECHO_PREFIX) Copying $< to $@
	$(CMD_PREFIX) cp -f $< $@

source/pjsip-apps/lib/asterisk_malloc_debug.o: source/pjsip-apps/src/asterisk_malloc_debug.c .rebuild_needed
	$(ECHO_PREFIX) Compiling asterisk debug malloc stubs
	$(CMD_PREFIX) $(CC) -fPIC  $(PJ_CFLAGS) -c $< -o $@

source/pjsip-apps/lib/libasterisk_malloc_debug.a: source/pjsip-apps/lib/asterisk_malloc_debug.o
	$(ECHO_PREFIX) Creating archive $(@F)
	$(CMD_PREFIX) ar qs $@ $< >/dev/null 2>&1

$(apps): APP = $(filter pj%,$(subst -, ,$(notdir $@)))
$(apps): LDFLAGS += $(MALLOC_DEBUG_LDFLAGS)
$(apps): $(MALLOC_DEBUG_LIBS) pjproject.symbols $(APP_THIRD_PARTY_LIB_FILES)
	$(ECHO_PREFIX) Compiling $(APP)
	$(CMD_PREFIX) +$(MAKE) -C source/pjsip-apps/build $(filter pj%,$(subst -, ,$(notdir $@))) $(REALLY_QUIET)

source/pjsip-apps/src/python/_pjsua.o: source/pjsip-apps/src/python/_pjsua.c $(apps)
	$(ECHO_PREFIX) Compiling python bindings
	$(CMD_PREFIX) $(CC) -o $@ -c $< $(PYTHONDEV_INCLUDE) $(CFLAGS) $(PJ_CFLAGS)

source/pjsip-apps/src/python/_pjsua.so: LDFLAGS += $(MALLOC_DEBUG_LDFLAGS)
source/pjsip-apps/src/python/_pjsua.so: source/pjsip-apps/src/python/_pjsua.o
	$(ECHO_PREFIX) Linking python bindings $(@F)
	$(CMD_PREFIX) gcc -shared -pthread -o $@ $< $(LDFLAGS) $(PJ_LDFLAGS) $(APP_LDLIBS) $(PYTHONDEV_LIB) $(REALLY_QUIET)

_install: _all
	@if [ ! -d "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject" ]; then \
		$(INSTALL) -d "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject"; \
	fi;
ifneq ($(findstring source/pjsip-apps/bin/pjsua-$(TARGET_NAME),$(TARGETS)),)
	$(ECHO_PREFIX) Installing apps
	$(CMD_PREFIX) $(INSTALL) -m 755 source/pjsip-apps/bin/pjsua-$(TARGET_NAME) "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/pjsua"
	$(CMD_PREFIX) $(INSTALL) -m 755 source/pjsip-apps/bin/pjsystest-$(TARGET_NAME) "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/pjsystest"
endif
ifneq ($(findstring _pjsua.so,$(TARGETS)),)
	$(ECHO_PREFIX) Installing python bindings
	$(CMD_PREFIX) $(INSTALL) -m 755 source/pjsip-apps/src/python/_pjsua.so "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/"
	$(CMD_PREFIX) $(INSTALL) -m 644 source/pjsip-apps/src/python/pjsua.py "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/"
endif

uninstall:
	$(ECHO_PREFIX) Uninstalling apps and python bindings
	$(CMD_PREFIX) rm -rf "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject"

clean:
	$(ECHO_PREFIX) Cleaning
	+-$(CMD_PREFIX) test -d source && ($(SUBMAKE) -C source clean || : ;\
		rm -rf source/pjsip-apps/bin/* || : ;\
		find source -name *.a | xargs rm -rf  ;\
		find source -name *.o | xargs rm -rf  ;\
		find source -name *.so  | xargs rm -rf ; ) || :
	-$(CMD_PREFIX) rm -rf pjproject.symbols

distclean:
	$(ECHO_PREFIX) Distcleaning
	-$(CMD_PREFIX) rm -rf source pjproject.symbols pjproject-*.tar.bz2 build.mak .rebuild_needed

## asterisk-certified 16.8-cert14

=== debian/changelog ===
asterisk-certified (16.8-cert14-1bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Fri, 24 Jun 2022 10:25:28 +0200

asterisk-certified (16.8-cert13-1bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Mon, 21 Mar 2022 16:07:14 +0100

asterisk-certified (16.8-cert12-0bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Sat, 30 Oct 2021 17:17:45 +0200

asterisk-certified (16.8-cert11-0bit1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Mon, 16 Aug 2021 16:18:15 +0200

asterisk-certified (16.8-cert7-0bit3) unstable; urgency=medium

  * Built without sound files, Recommends asterisk-cert-moh-opsound-wav instead. Sound
    files are installed by FreePBX automatically.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Fri, 04 Jun 2021 15:37:24 +0200

asterisk-certified (16.8-cert7-0bit2) unstable; urgency=medium

  * Renamed service from asterisk-cert to asterisk.
  * Bump debhelper compat to v12.
  * Using debhelper-compat B-D.

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Fri, 30 Apr 2021 20:50:46 +0200

asterisk-certified (16.8-cert7-0bit1) unstable; urgency=medium

  * Initial release.
  * Removed configure parameter --without-pwlib, it does not exists.
  * Enabled codecs: mp3, iLBC
  * Enabled external codecs: opus, silk, siren7, siren14

 -- Daniel Betschart <daniel.betschart@betschart-it.ch>  Mon, 22 Mar 2021 17:09:10 +0100

=== debian/control ===
Source: asterisk-certified
Section: comm
Priority: optional
Maintainer: Daniel Betschart <daniel.betschart@betschart-it.ch>
Build-Depends:
 debhelper-compat (= 12),
 autoconf,
 subversion,
 automake,
 binutils-dev,
 dahdi-source,
 default-libmysqlclient-dev,
 freetds-dev,
 libasound2-dev,
 libavcodec-dev,
 libavdevice-dev,
 libbluetooth-dev [linux-any],
 libc-client2007e-dev,
 libcap-dev [linux-any],
 libcurl4-openssl-dev | libcurl-dev,
 libedit-dev,
 libradcli-dev | libfreeradius-client-dev | libradiusclient-ng-dev,
 libgmime-3.0-dev,
 libgsm1-dev,
 libical-dev,
 libiksemel-dev,
 libjack-dev,
 libjansson-dev (>= 2.11),
 libldap-dev,
 liblua5.1-0-dev,
 libncurses-dev,
 libneon27-gnutls-dev | libneon27-dev,
 libnewt-dev,
 libogg-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libopenr2-dev [linux-any],
 libopus-dev,
 libopusfile-dev,
 libpopt-dev,
 libpq-dev,
 libpri-dev,
 libreadline-dev,
 libresample1-dev,
 libsdl-image1.2-dev,
 libsnmp-dev,
 libspandsp-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libsqlite3-dev,
 libsrtp2-dev,
 libss7-dev,
 libssl-dev,
 libsystemd-dev [linux-any],
 libswscale-dev,
 libtonezone-dev [linux-any],
 libunbound-dev,
 liburiparser-dev,
 libvorbis-dev,
 libvpb-dev [linux-any],
 libxml2-dev,
 libxslt1-dev,
 portaudio19-dev,
 unixodbc-dev,
 uuid-dev,
 linux-libc-dev,
 wget,
 ca-certificates,
 libcodec2-dev,
 xmlstarlet,
 pkg-config,
 zlib1g-dev
Standards-Version: 4.3.0
Homepage: http://www.asterisk.org/
#Vcs-Browser: https://salsa.debian.org/debian/asterisk-cert-certified
#Vcs-Git: https://salsa.debian.org/debian/asterisk-cert-certified.git

Package: asterisk-cert
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 adduser,
 asterisk-cert-config (= ${source:Version}) | asterisk-config-custom,
 asterisk-cert-modules (= ${binary:Version}),
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 asterisk-cert-${asterisk:ABI}
Recommends:
 asterisk-cert-moh-opsound-wav,
 asterisk-cert-voicemail | asterisk-cert-voicemail-storage,
 sox, mpg123
Suggests:
 asterisk-cert-dahdi,
 asterisk-cert-dev,
 asterisk-cert-doc,
 asterisk-cert-ooh323,
 asterisk-cert-vpb
Description: Open Source Private Branch Exchange (PBX)
 Asterisk is an Open Source PBX and telephony toolkit.  It is, in a
 sense, middleware between Internet and telephony channels on the bottom,
 and Internet and telephony applications at the top.
 .
 Asterisk can be used with Voice over IP (SIP, H.323, IAX and more) standards,
 or the Public Switched Telephone Network (PSTN) through supported hardware.
 .
 Supported hardware:
 .
  * All Wildcard (tm) ISDN PRI cards from Digium (http://www.digium.com)
  * HFC-S/HFC-4S-based ISDN BRI cards (Junghanns.NET, beroNet, Digium etc.)
  * All TDM (FXO/FXS) cards from Digium
  * Various clones of Digium cards such as those by OpenVox
  * Xorcom Astribank USB telephony adapter (http://www.xorcom.com)
  * Voicetronix OpenPCI, OpenLine and OpenSwitch cards
  * CAPI-compatible ISDN cards (using the add-on package chan-capi)
  * Full Duplex Sound Card (ALSA or OSS) supported by Linux
  * Tormenta T1/E1 card (http://www.zapatatelephony.org)
  * QuickNet Internet PhoneJack and LineJack (http://www.quicknet.net)
 .
 This is the main package that includes the Asterisk daemon and most channel
 drivers and applications.

Package: asterisk-cert-modules
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Section: libs
Description: loadable modules for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes most of the loadable modules of the Asterisk package.
 There is normally no need to explicitly install it.

Package: asterisk-cert-dahdi
Architecture: linux-any
Depends:
 asterisk-cert (= ${binary:Version}),
 dahdi,
 ${misc:Depends},
 ${shlibs:Depends}
Breaks:
 asterisk-cert-modules (<< 1:11.6.0~dfsg-2)
Replaces:
 asterisk-cert-modules (<< 1:11.6.0~dfsg-2)
Description: DAHDI devices support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes the DAHDI channel driver (chan_dahdi.so) and a number of
 other Asterisk modules that require DAHDI support. They will not be useful
 without kernel-level DAHDI support.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-vpb
Architecture: linux-any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Breaks:
 asterisk-cert-modules (<< 1:11.6.0~dfsg-1)
Replaces:
 asterisk-cert-modules (<< 1:11.6.0~dfsg-1)
Description: VoiceTronix devices support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes the VoiceTronix channel driver (chan_vpb.so).
 It will not be useful without kernel-level VoiceTronix support.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-voicemail
Architecture: any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 asterisk-cert-voicemail-storage
Conflicts:
 asterisk-cert-voicemail-storage
Description: simple voicemail support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes the standard files-based voicemail storage. This
 is normally the one you use and is the one that will Just Work. The only
 reason not to install it is if you want to use a different Asterisk
 voicemail storage (ODBC or IMAP).
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-voicemail-imapstorage
Architecture: any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 asterisk-cert-voicemail-storage
Conflicts:
 asterisk-cert-voicemail-storage
Description: IMAP voicemail storage support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes an IMAP-based voicemail storage: storing the
 voicemail in a remote IMAP mail boxes. While more complex to set up,
 it may be useful in some settings.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-voicemail-odbcstorage
Architecture: any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 asterisk-cert-voicemail-storage
Conflicts:
 asterisk-cert-voicemail-storage
Description: ODBC voicemail storage support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes an database-based voicemail storage: storing the
 voicemail in a database accessed through the ODBC interface. While more
 complex to set up, it may be useful in some settings.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-ooh323
Architecture: any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: H.323 protocol support for the Asterisk PBX - ooH323c
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This channel driver (chan_ooh323c) provides support for the H.323 protocol
 for Asterisk. This is an independent implementation that does not depend
 on OpenH323, but may be less functional than the original chan_h323.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-mp3
Architecture: any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: MP3 playback support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support for playing MP3-encoded files in
 Asterisk.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-mysql
Architecture: any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: MySQL database protocol support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support for using a MySQL database to store
 configuration, call detail records, and also provides generic access to
 it from the dialplan.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-mobile
Architecture: linux-any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Bluetooth phone support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support for connecting Bluetooth devices to the
 Asterisk PBX. It allows you to:
   * Send and receive PSTN calls and SMS messages over a Bluetooth phone.
   * Use a Bluetooth handset as a local phone connected to your PBX.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-tests
Architecture: linux-any
Depends:
 asterisk-cert (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: internal test modules of the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides modules that run various functionality tests.
 You would normally not install this package unless you test a build
 of Asterisk.
 .
 For more information about the Asterisk PBX, have a look at the Asterisk
 package.

Package: asterisk-cert-doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Recommends:
 asterisk-cert
Section: doc
Description: Source code documentation for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the documentation for configuring an Asterisk system.

Package: asterisk-cert-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Recommends:
 asterisk-cert
Section: devel
Description: Development files for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the include files used if you wish to compile a
 package which requires Asterisk's source file headers.

Package: asterisk-cert-config
Depends:
 ${misc:Depends}
Recommends:
 asterisk-cert
Conflicts:
 asterisk-config-custom
Replaces:
 asterisk-config-custom
Architecture: all
Description: Configuration files for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the default configuration files of Asterisk.
 .
 With program asterisk-cert-config-custom in the asterisk package,
 you can create an asterisk-config replacement package.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Starting with dpkg-dev >= 1.16.1.1 you can use the new buildflags.mk file
# to set all *FLAGS
# When building programs that handle untrusted data
# (parsers, network listeners, etc.),
#  or run with elevated privileges (PAM, X, etc.),
#  please enable "PIE" and "BINDNOW" in the build.
#  The "all" option enables "PIE" and "BINDNOW" and future hardening flags

%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Sanity check for a stable release:
SAVED_ABI_HASH = 1fb7f5c06d7a2052e38d021b3d8ca151

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  confflags += --build $(DEB_HOST_GNU_TYPE)
else
  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

# We copy around a number of things in case we're linux:
BUILD_OS=$(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

export PROC := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)

# don't let asterisk mess with build flags
BUILDFLAGS += AST_FORTIFY_SOURCE= DEBUG= OPTIMIZE=

# show full gcc arguments instead of [CC] and [LD]
BUILDFLAGS += NOISY_BUILD=yes

BUILDFLAGS += ASTDATADIR=/var/lib/asterisk ASTVARRUNDIR=/run/asterisk

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	ENABLE_DEBUG += --enable-dev-mode
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

include /usr/share/dpkg/pkg-info.mk
DEBVERSION:=$(DEB_VERSION)
DEB_NOEPOCH_VERSION:=$(shell echo $(DEBVERSION) | cut -d':' -f 2)

# make sure we have 'fetch' . We need to have either wget or fetch
# on the system. However it is generally not a good idea to actually
# get remote tarballs at build time. So if neither wget nor fetch
# happen to be installed, the configure script will find a dummy
# fetch script that always returns an error.
FETCH_ENV = PATH=$$PATH:$(CURDIR)/debian/dummyprogs

# resolve if release is experimental
EXP_RELEASE := $(if $(shell dpkg-parsechangelog | grep '^Distribution: \(experimental\|UNRELEASED\)'),exp)

override_dh_autoreconf:
	if [ ! -r configure.debian_sav -a -r configure ]; then cp -a configure configure.debian_sav; fi
	[ -f .version.debian_sav ] || cp -a .version .version.debian_sav
	echo $(DEB_NOEPOCH_VERSION) > .version
	dh_autoreconf -- ./bootstrap.sh

# Make sure the configure script gets an CFLAGS parameter. Otherwise
# it will build with -march=native
# Pass CPPFLAGS in the CFLAGS as otherwise the build system will
# ignore them.
override_dh_auto_configure:
	chmod 755 $(CURDIR)/debian/dummyprogs/fetch
	$(FETCH_ENV) ./configure			\
		CFLAGS="-fgnu89-inline $(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS) -Wl,--as-needed" \
		--host=$(DEB_HOST_GNU_TYPE)		\
		--build=$(DEB_BUILD_GNU_TYPE)		\
		--prefix=/usr				\
		--mandir=\$${prefix}/share/man		\
		--infodir=\$${prefix}/share/info	\
		--disable-asteriskssl			\
		--with-gsm				\
		--with-imap=system			\
		--with-jansson-bundled			\
		--with-pjproject-bundled		\
		$(if $(EXP_RELEASE),,--without-sdl) \
		${ENABLE_DEBUG} || { cat config.log; exit 1; }


override_dh_auto_build:
	$(MAKE) menuselect.makeopts BUILD_CFLAGS="$(CFLAGS) $(CPPFLAGS)" BUILD_LDFLAGS="$(LDFLAGS)"
	menuselect/menuselect --enable app_macro menuselect.makeopts
#	Codec Translators
#	menuselect/menuselect --enable codec_codec2 menuselect.makeopts

#	Codec Translators External
#	menuselect/menuselect --enable codec_opus_open_source menuselect.makeopts
	menuselect/menuselect --enable codec_opus menuselect.makeopts
	menuselect/menuselect --enable codec_silk menuselect.makeopts
	menuselect/menuselect --enable codec_siren7 menuselect.makeopts
	menuselect/menuselect --enable codec_siren14 menuselect.makeopts

#	Format Interpreters
	menuselect/menuselect --enable format_ogg_speex menuselect.makeopts
	menuselect/menuselect --enable format_vox menuselect.makeopts
	menuselect/menuselect --enable format_mp3 menuselect.makeopts

#	enable non-core modules
#	Applications
	menuselect/menuselect --enable app_alarmreceiver menuselect.makeopts
	menuselect/menuselect --enable app_amd menuselect.makeopts
	menuselect/menuselect --enable app_attended_transfer menuselect.makeopts
	menuselect/menuselect --enable app_blind_transfer menuselect.makeopts
	menuselect/menuselect --enable app_chanisavail menuselect.makeopts
	menuselect/menuselect --enable app_dictate menuselect.makeopts
	menuselect/menuselect --enable app_externalivr menuselect.makeopts
	menuselect/menuselect --enable app_festival menuselect.makeopts
	menuselect/menuselect --enable app_jack menuselect.makeopts
	menuselect/menuselect --enable app_minivm menuselect.makeopts
	menuselect/menuselect --enable app_morsecode menuselect.makeopts
	menuselect/menuselect --enable app_mp3 menuselect.makeopts
	menuselect/menuselect --enable app_sms menuselect.makeopts
	menuselect/menuselect --enable app_test menuselect.makeopts
	menuselect/menuselect --enable app_waitforring menuselect.makeopts
	menuselect/menuselect --enable app_waitforsilence menuselect.makeopts
	menuselect/menuselect --enable app_zapateller menuselect.makeopts
	menuselect/menuselect --enable app_adsiprog menuselect.makeopts
	menuselect/menuselect --enable app_dahdiras menuselect.makeopts
	menuselect/menuselect --enable app_getcpeid menuselect.makeopts
	menuselect/menuselect --enable app_ices menuselect.makeopts
	menuselect/menuselect --enable app_image menuselect.makeopts
	menuselect/menuselect --enable app_nbscat menuselect.makeopts
	menuselect/menuselect --enable app_url menuselect.makeopts

#	CDR
	menuselect/menuselect --enable cdr_csv menuselect.makeopts
	menuselect/menuselect --enable cdr_odbc menuselect.makeopts
	menuselect/menuselect --enable cdr_pgsql menuselect.makeopts
	menuselect/menuselect --enable cdr_radius menuselect.makeopts
	menuselect/menuselect --enable cdr_sqlite3_custom menuselect.makeopts
	menuselect/menuselect --enable cdr_tds menuselect.makeopts

#	CEL
	menuselect/menuselect --enable cel_pgsql menuselect.makeopts
	menuselect/menuselect --enable cel_radius menuselect.makeopts
	menuselect/menuselect --enable cel_sqlite3_custom menuselect.makeopts
	menuselect/menuselect --enable cel_tds menuselect.makeopts

#	Channel Drivers
	menuselect/menuselect --enable chan_alsa menuselect.makeopts
	menuselect/menuselect --enable chan_console menuselect.makeopts
	menuselect/menuselect --enable chan_mgcp menuselect.makeopts
	menuselect/menuselect --enable chan_sip menuselect.makeopts
	menuselect/menuselect --enable chan_skinny menuselect.makeopts
	menuselect/menuselect --enable chan_unistim menuselect.makeopts
	menuselect/menuselect --enable chan_oss menuselect.makeopts
	menuselect/menuselect --enable chan_phone menuselect.makeopts
	menuselect/menuselect --enable chan_vpb menuselect.makeopts

#	Dialplan Functions
	menuselect/menuselect --enable func_frame_trace menuselect.makeopts
	menuselect/menuselect --enable func_pitchshift menuselect.makeopts

#	PBX Modules
	menuselect/menuselect --enable pbx_ael menuselect.makeopts
	menuselect/menuselect --enable pbx_dundi menuselect.makeopts
	menuselect/menuselect --enable pbx_lua menuselect.makeopts
	menuselect/menuselect --enable pbx_realtime menuselect.makeopts

#	Resource Modules
	menuselect/menuselect --enable res_timing_pthread menuselect.makeopts
	menuselect/menuselect --enable res_phoneprov menuselect.makeopts
#	menuselect/menuselect --enable res_pjsip menuselect.makeopts
	menuselect/menuselect --enable res_pjsip_history menuselect.makeopts
	menuselect/menuselect --enable res_pjsip_phoneprov_provider menuselect.makeopts
	menuselect/menuselect --enable res_hep menuselect.makeopts
	menuselect/menuselect --enable res_hep_pjsip menuselect.makeopts
	menuselect/menuselect --enable res_hep_rtcp menuselect.makeopts

#	Debug Functions
	@if [ "x${ENABLE_DEBUG}" != "x" ] ; then \

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update

# opts="repack,compression=xz,dversionmangle=s/~dfsg\d*$//,repacksuffix=~dfsg,pgpsigurlmangle=s/$/.asc/" \

version=4
	opts="repack,compression=xz,pgpsigurlmangle=s/$/.asc/" \
	https://downloads.asterisk.org/pub/telephony/certified-asterisk/releases/asterisk-certified-(16.[0-9.*]-cert[0-9][0-9]).tar.gz debian uupdate
